package 
{
	import fl.motion.Tweenables;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.geom.Point;
	import flash.display.DisplayObject;
	import flash.display.Stage;
	import fl.transitions.easing.Regular;
	
	//TEST FOE////////////////////////////////////////////////
	//for testing foe animations in test harness swf.		//
	//includes simple animation related function for foes.	//
	//////////////////////////////////////////////////////////
	
	public class TestFoe extends MovieClip {
		
		public static var STAGE:Stage;
		public static var ROOT:MovieClip;
		
		public var X:Number;
		public var Y:Number;
		public var OX:Number;
		public var OY:Number;
		
		public var head:MovieClip;
		public var body:MovieClip;
		public var eye1:MovieClip;
		public var eye2:MovieClip;
		
		public var freeze:Boolean = false;
		
		public var point1:MovieClip;
		public var point2:MovieClip;
		public var point3:MovieClip;
		public var point4:MovieClip;
		
		public var tween1:Tween;
		public var tween2:Tween;
		public var tween3:Tween;
		public var skin:int = 1;
		public var weapon:int = 1;
		
		//public var head:MovieClip;
		
		public var loops:int = 0;
		public var skinDamage:int = 1;
		
		//fake classes and objects to keep code happy
		public var Text:Object;
		public var self:Object;
		public var Battle:Object;
		public var Players:Object;
		
		public var isSummon:Boolean = false;
		
		public function f() { }
		
		public function f2(n:int = 0) { 
			
			if (parent.targetAll) {
				parent.targetAll = false;
				parent.p1.pauseNestedAnimations = true;
				parent.p2.pauseNestedAnimations = true;
				parent.p3.pauseNestedAnimations = true;
				
				parent.p1.gotoAndPlay("hit1");
				parent.p2.gotoAndPlay("hit1");
				parent.p3.gotoAndPlay("hit1");
			} else {
				parent.selectedTarget.pauseNestedAnimations = true;
				parent.selectedTarget.gotoAndPlay("hit1");
			}
		}
		
		public var pauseNestedAnimations:Boolean = true;
		public function dropItems() { };
		public function defend1() { };
		public function freezeSound() { playSound("freeze"); };
		public function flee() { stop(); };
		
		//init vars
		public function init() {
			target = parent.p1;
			STAGE = stage;
			ROOT = parent;
			Global.root = root;
			trace("init foe!");
			
			OX = this.x;
			OY = this.y;	
			playNestedClips(false);
			originalLayer = parent.getChildIndex(this);
			
			gotoAndPlay("intro");
			
			Text = {speech:function(a:* = null){} , foes:[], hydra:[], worms:[], wraiths:[]};
			self = {defend1: f, attack1: f2, attack2: f2, attack3: f2, attack4: f2, attack5: f2, attack6: f2, attack7: f2, attack8: f2, magic1: f,magic2: f,magic3: f,magic4: f, change1: f, special1: f2, special2: f2, special3: f2, special4: f2, special5: f2, special6: f2, special7: f2, special8: f2, special9: f2}
			Battle = { foeCount:function() { }, shake:function(s:String = "small") { parent.shaker.gotoAndPlay(s); }, currentPlayer:null };
			Players = {player1:null, player2:null, player3:null, player4:null};
		}
		
		//update status icons during stand animation
		public function stand() {
			pauseNestedAnimations = false;
			if (!Options.idleFoes) {
				stop();
			}
		}
		
		//swap current layer when moving
		public function swap() {
			
		}
		
		public static var soundV:Vector.<String>;
		public static function playSound(sound:String) {
			/*
			if (soundV) {
				//trace("cancel");
				//trace(soundV);
				if (soundV.indexOf(sound) != -1) return;
				soundV.push(sound);
			} else {
				soundV = new Vector.<String>;
			}
			*/
			try{
			ROOT.sounds.gotoAndStop(sound);
			ROOT.sounds.gotoAndStop(1);
			}catch (e:Error) { trace("Sound not found: " + sound); }
		}
		
		public function randomDelay(d:int = 20) {
			gotoAndPlay(currentFrame+int(Math.random()*d));
		}
		
		
		//called at end of animations
		public function k() {
			gotoAndPlay("stand");
			playNestedClips(true);
		}
		
		//depricated
		public function playNestedClips(play:Boolean) {
			return;
			
			//trace("SCANNING MC------------");
			for(var i:int = 0; i < numChildren; i++){
				var e:DisplayObject = getChildAt(i);
				if(e is MovieClip){
					for(var j:int = 0; j < e.numChildren; j++){
						var d:DisplayObject = e.getChildAt(j);
						if (d is MovieClip) {
							if (play) d.play();
							else d.stop();
						}
					}
				}
			}
		}
		
		public function makeMagic(magic:Class, X:Number = 0, Y:Number = 0, multiple:Boolean = false) {
			if (multiple) {
				for each (var p:TestFoe in [parent.p1, parent.p2, parent.p3]) {
					var mc:MovieClip = new magic();
					parent.addChild(mc);
					parent.selectedTarget = p;
					mc.positionOnTarget();
					mc.skin = this.skin;
				}
			}
			else{
				mc = new magic();
				parent.addChild(mc);
				//parent.setChildIndex(mc, parent.getChildIndex(parent.selectedTarget) + 1);
				
				if (X != 0 || Y != 0 ){
					mc.x = X;
					mc.y = Y;
				}
				mc.skin = this.skin;
				//mc.gotoAndPlay(2);
				mc.gotoAndPlay(1);
			}
		}
		
		//called at end of stand animation
		public function ks() {
			gotoAndPlay("stand");
		}
		
		//called at end of death animation
		public function dead() {
			stop();
		}
		
		//called at end of animations that don't return to stand
		public function done() {
			stop();
		}
		
		//called at end of freeze animation
		public function frozen() {
			freeze = true;
			stand();
			done();
		}

		//move whole foe
		public function run(){
			//x += X; 
			//y += Y;
		};
		
		public var moveOut:Boolean = true;
		public var target:MovieClip;
		public function setXY() {
			moveOut = true;
			//target = parent.selectedTarget;
			target = parent.getRandomPlayer();
			//target = parent.p3;
			X = (target as MovieClip).localToGlobal(new Point(target.point2.x, target.point2.y)).x;
			Y = (target as MovieClip).localToGlobal(new Point(target.point2.x, target.point2.y)).y;
		}
		
		public function setXYF() {
			moveOut = true;
			//target = parent.selectedTarget;
			target = parent.getRandomFoe();
			//target = parent.p3;
			X = (target as MovieClip).localToGlobal(new Point(target.point2.x, target.point2.y)).x;
			Y = (target as MovieClip).localToGlobal(new Point(target.point2.x, target.point2.y)).y;
		}
		
		public function resetXY() {
			moveOut = false;
			X = OX;
			Y = OY;
		}
		
		private var originalLayer:int;
		public function swapLayer() {
			//parent.setChildIndex(this, parent.getChildIndex(target));
		}
		
		public function resetLayer() {
			parent.setChildIndex(this, originalLayer);
		}
		
		//tween this to target
		public function move(offset:Number, frames:int, easing:Function) {
			if(moveOut){
				tween1 = new Tween(this, "x", easing, this.x, X + offset - this.localToGlobal(new Point(point2.x, point2.y)).x + this.x, frames);
				tween2 = new Tween(this, "y", easing, this.y, Y  - this.localToGlobal(new Point(point2.x, point2.y)).y + this.y, frames);
			} else {
				tween1 = new Tween(this, "x", easing, this.x, X + offset, frames);
				tween2 = new Tween(this, "y", easing, this.y, Y, frames);
			}
		}

	}
	
}