package 
{
	import fl.motion.Tweenables;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import fl.transitions.Tween;
	import fl.transitions.easing.*;
	import flash.geom.Point;
	import flash.display.DisplayObject;
	import flash.display.Stage;
	import fl.transitions.easing.Regular;
	
	//TEST PLAYER/////////////////////////////////////////////////////////
	//for testing player animations and equips in test harness swf.		//
	//includes simple animation related functions.						//
	//////////////////////////////////////////////////////////////////////
	
	public class TestPlayer extends MovieClip {
		
		public static var STAGE:Stage;
		public static var ROOT:MovieClip;
		
		public var X:Number;
		public var Y:Number;
		public var OX:Number;
		public var OY:Number;
		
		public var freeze:Boolean = false;
		
		public var point1:MovieClip;
		public var point2:MovieClip;
		public var point3:MovieClip;
		public var point4:MovieClip;
		
		public var idle:MovieClip;
		public var playerNo:int;
		
		public var pauseNestedAnimations:Boolean = true;
		
		public var deathFace:int = Math.random()*12+2;
		
		public var tween1:Tween;
		public var tween2:Tween;
		public var tween3:Tween;
		public var skin:int = 1;
		
		//fake classes and objects to keep code happy
		public var Text:Object;
		public var self:Object;
		public var Battle:Object;
		//public var Players:Object;
		
		public var hideMouth:Boolean = false;
		public var hideEyes:Boolean = false;
		
		public function f(i:int = 1) { }
		public function f2(i:int = 1){}
		public function f3(i:int = 1) { 
			
			if (parent.targetAll) {
				parent.targetAll = false;
				parent.f1.pauseNestedAnimations = true;
				parent.f2.pauseNestedAnimations = true;
				parent.f3.pauseNestedAnimations = true;
				
				parent.f1.gotoAndPlay("hit1");
				parent.f2.gotoAndPlay("hit1");
				parent.f3.gotoAndPlay("hit1");
			} else {
				parent.selectedTarget.pauseNestedAnimations = true;
				parent.selectedTarget.gotoAndPlay("hit1");
			}
			
			}
		
		//init vars
		public function init() {
			STAGE = stage;
			ROOT = root;
			trace("init foe!");
			
			OX = this.x;
			OY = this.y;	
			
			originalLayer = parent.getChildIndex(this);
			
			gotoAndPlay("intro");
			
			Text = {speech:function(){} , death: f2, revive: f2, eat: f2,  foes:[]};
			self = {attack1: f3, attack2: f3, castSpell: f, unfreeze: f, attack3: f3, attack4: f3, attack5: f3,attack6: f3,attack7: f3,attack8: f3, magic1: f,magic2: f,magic3: f,magic4: f, change1: f, special1: f3, special2: f, special3: f3, special4: f3,special5: f,special6: f, defend: f, death: f, setEquipGraphics: f, eat: f, eatItem: k, throwItem: f3, passItem: f, revive: f, shoot1: f, shoot2: f, shoot3: f, shoot4: f, shoot5: f}
			Battle = {shake:function(s:String = "small"){parent.shaker.gotoAndPlay(s);}, currentPlayer:null, standby: f, bonusSpell: f2, currentFoe: false};
			//Players = {player1:null, player2:null, player3:null, player4:null};
		}
		
		//update status icons during idle animation
		public function stand() {
			pauseNestedAnimations = false;
			stop();
			if(idle)idle.playerNo = playerNo;
			
			//display status
			//if(Battle.stage) self.statusDisplay.visible = true;
			//if(Battle.stage) self.statusDisplay.update(self);
			
		}
		
		//swap current layer when moving
		public function swap() {
			
		}
		
		//nolegs weapon effects
		public function getElementEffect():Class {
			if (Players.P5equips[0] == 20) return EffectSmash; //hammer
			if (Players.P5equips[0] == 13) return EffectIce; //ice staff
			if (Players.P5equips[0] == 4) return EffectPixels; //pixels
			if (Players.P5equips[0] == 5) return EffectFeathers; //crucifix
			if (Players.P5equips[0] == 10) return EffectLeaves; //stick
			if (Players.P5equips[0] == 18) return EffectStab; //thief
			if (Players.P5equips[0] == 17) return EffectSlap2; //baton
			
			if (Global.element == "none") 		return EffectStab;
			if (Global.element == "fire") 		return EffectFire;
			if (Global.element == "ice") 		return EffectIce2;
			if (Global.element == "thunder") 	return EffectThunder2;
			if (Global.element == "wind") 		return EffectWind;
			if (Global.element == "earth") 		return EffectEarth;
			if (Global.element == "water") 		return EffectWater2;
			if (Global.element == "bio") 		{ playSound("poison"); return EffectPoison; }
			if (Global.element == "bomb") 		return EffectSmash2;
			if (Global.element == "dark") 		return EffectDark;
			if (Global.element == "holy") 		{ playSound("holy"); return EffectCircle; }
		}
		
		public function drainage() {
			return false;
		}
		
		public static var soundV:Vector.<String>;
		public static function playSound(sound:String) {
			//trace("SFX");
			if (soundV) {
				//trace("cancel");
				//trace(soundV);
				if (soundV.indexOf(sound) != -1) return;
				soundV.push(sound);
			} else {
				soundV = new Vector.<String>;
			}
			
			ROOT.sounds.gotoAndStop(sound);
			ROOT.sounds.gotoAndStop(1);
			
		}
		
		public function makeMagic(magic:Class, X:Number = 0, Y:Number = 0, multiple:Boolean = false) {
			if (multiple) {
				for each (var p:TestFoe in [parent.f1, parent.f2, parent.f3]) {
					var mc:MovieClip = new magic();
					parent.addChild(mc);
					parent.selectedTarget = p;
					mc.gotoAndPlay(1);
					//mc.positionOnTarget();
					mc.skin = this.skin;
				}
			}
			else{
				mc = new magic();
				parent.addChild(mc);
				//parent.setChildIndex(mc, parent.getChildIndex(parent.selectedTarget) + 1);
				
				if (X != 0 || Y != 0 ){
					mc.x = X;
					mc.y = Y;
				}
				mc.skin = this.skin;
				//mc.gotoAndPlay(2);
				mc.gotoAndPlay(1);
			}
		}
		
		
		//called at end of animations
		public function k() {
			gotoAndPlay("stand");
			playNestedClips(true);
		}
		
		public function playNestedClips(play:Boolean) {
			return;
			//trace("SCANNING MC------------");
			for(var i:int = 0; i < numChildren; i++){
				var e:DisplayObject = getChildAt(i);
				if(e is MovieClip){
					for(var j:int = 0; j < e.numChildren; j++){
						var d:DisplayObject = e.getChildAt(j);
						if (d is MovieClip) {
							if (play) d.play();
							else d.stop();
						}
					}
				}
			}
		}
		
		//called at end of idle animation
		public function ks() {
			gotoAndPlay("stand");
		}
		
		//called at end of death animation
		public function dead() {
			stop();
		}
		
		//called at end of animations that don't return to idle
		public function done() {
			stop();
		}
		
		//called at end of freeze animation
		public function frozen() {
			freeze = true;
			stand();
			done();
		}

		//move whole foe
		public function run(){
			//x += X; 
			//y += Y;
		};
		
		public var moveOut:Boolean = true;
		public var target:MovieClip;
		public function setXY() {
			moveOut = true;
			target = parent.getRandomPlayer();
			//target = parent.p3;
			X = (target as MovieClip).localToGlobal(new Point(target.point2.x, target.point2.y)).x;
			Y = (target as MovieClip).localToGlobal(new Point(target.point2.x, target.point2.y)).y;
		}
		
		public function resetXY() {
			moveOut = false;
			X = OX;
			Y = OY;
		}
		
		private var originalLayer:int;
		public function swapLayer() {
			//parent.setChildIndex(this, parent.getChildIndex(target));
		}
		
		public function resetLayer() {
			//parent.setChildIndex(this, originalLayer);
		}
		
		//tween this to target
		public function move(offset:Number, frames:int, easing:Function) {
			if(moveOut){
				tween1 = new Tween(this, "x", easing, this.x, X + offset - this.localToGlobal(new Point(point2.x, point2.y)).x + this.x, frames);
				tween2 = new Tween(this, "y", easing, this.y, Y  - this.localToGlobal(new Point(point2.x, point2.y)).y + this.y, frames);
			} else {
				tween1 = new Tween(this, "x", easing, this.x, X + offset, frames);
				tween2 = new Tween(this, "y", easing, this.y, Y, frames);
			}
		}

	}
	
}